<template>
  <div class="tree-item">
    <li>
      <el-checkbox :label="itemList.id" v-if="showCheckbox" @change="checkItem(itemList)">{{itemList.name}}</el-checkbox>
      <span v-else>{{itemList.name}}</span>
      <ul v-if="hasChild" :class="hasGrandson?'':'last-child'">
        <tree-item v-for="(item,i) in itemList.children" :key="i" :selectedList="selectedList" :itemList="item"></tree-item>
      </ul>
    </li>
  </div>
</template>

<script>
  export default {
    name: 'TreeItem',
    props: {
      itemList: {
        type: [Object, Array]
      },
      selectedList:{
        type:[Object]
      }
    },
    inject: ['showCheckbox'],
    data() {
      return {
        check: true,
      }
    },
    computed: {
      hasChild() {
        return this.itemList.children && this.itemList.children.length > 0;
      },
      hasGrandson() {
        return this.itemList.children[0].children && this.itemList.children[0].children.length > 0;
      }
    },
    created() {
      
    },
    methods: {
      selectCheck() {
      },
      // 选中子节点
      checkChlid(data){
        if(data.children&&data.children.length>0){
          data.children.map((item)=>{
            this.selectedList.selected.push(item.id);
            this.selectedList.selected=[...new Set([...this.selectedList.selected])];
            this.checkChlid(item.children);
          });
        }else{
          if(Array.isArray(data)){
            data.map((item)=>{
              this.selectedList.selected.push(item.id);
              this.selectedList.selected=[...new Set([...this.selectedList.selected])];
            });
          }else{
            this.selectedList.selected.push(data.id);
            this.selectedList.selected=[...new Set([...this.selectedList.selected])];
          }
        }
      },
      // 清除子节点
      clearChild(data){
        if(data.children&&data.children.length>0){
          data.children.map((item)=>{
            var set =new Set([...this.selectedList.selected]);
            if(set.delete(item.id)){
              this.selectedList.selected=[...set];
            }
            this.clearChild(item.children);
          });
        }else{
          if(Array.isArray(data)){
            data.map((item)=>{
              var set =new Set([...this.selectedList.selected]);
              if(set.delete(item.id)){
                this.selectedList.selected=[...set];
              }
            });
          }else{
            var set =new Set([...this.selectedList.selected]);
            if(set.delete(data.id)){
              this.selectedList.selected=[...set];
            }
          }
        }
      },
      //进行多选勾选
      checkItem(data) {
        var set =new Set([...this.selectedList.selected]);
        if(set.has(data.id)){
          this.checkChlid(data);
        }else{
          this.clearChild(data);
        }
      }
    }
  }
</script>

<style lang="less" scoped>
  .tree-item {
    ul {
      margin: 10px 0;
      padding-left: 20px;
    }
    .last-child {
      display: grid;
      grid-template-columns: repeat(auto-fit, 100px);
    }
  }
</style>